'Nome       : provisoes.GPE
'Tipo       : CFR
'Data       : 2004/03/18
'Versao     : 1.0
'Descricao  : 132 colunas 16CPI e modo grafico horiz.

'-------------------------------------------------------------------------------
#DEF - Definicao global do documento
'-------------------------------------------------------------------------------
Caracteres invalidos             [CarInv]=#
##


'-------------------------------------------------------------------------------
#ESP - Campos especificos
'-------------------------------------------------------------------------------
Zoom para preview             [PrvZoom]=1.5
Opcoes para impressora WIN   [PrWinOpc]=[ORI=L]
##


'-------------------------------------------------------------------------------
#SQL - Comandos SQL
'-------------------------------------------------------------------------------
Base de dados           [BD]=EmpFic$("EMP","Gpe,Gpe.mdb")

Dados a listar [Cmd]=GerDli=+
+SELECT GpeMst.Sec$ AS C01,GpeMst.Sec$ AS C02,GpeMst.Trb$ AS C03,GpeMst.Nome$ AS C04,GpeMst.Vbase AS C05,GpeMst.Vbase AS C06,GpeMst.Crss AS C07 +
+FROM GPEMST +
+WHERE GpeMst.SitEmp IN(11,12) +
+ORDER BY GpeMst.Sec$
##


'-------------------------------------------------------------------------------
#DOC - Configuracao do documento
'-------------------------------------------------------------------------------
Tipo                       [DocTip]=SQL
Nome                       [DocNom]=Doc1,Mapa Provises
Vias                       [DocVia]=Original

'formato
Saida/Impressora           [DocPrt]=
Linhas por pagina          [DocLpg]=50
Colunas por linha          [DocCol]=132
Formato do papel           [DocPap]=72L
Ajustar pagina             [DocApg]=0
Especifico do documento    [DocEsp]=TipoLst=TXT

'funcoes de listagem
Listar cabecalho            [FxCAB]=Doc1_Cab
Listar linhas               [FxLIN]=Doc1_Lin
Listar fim                  [FxFIM]=Doc1_Fim

'controlo de listagem SQL
Gerador de dados a listar  [SQLDat]=GerDli
Subtotalizadores           [SQLSbt]=C01
##


''-------------------------------------------------------------------------------
'#DOC - Configuracao do documento
''-------------------------------------------------------------------------------
'Tipo                       [DocTip]=SQL
'Nome                       [DocNom]=Doc1_G,Mapa Provises
'Vias                       [DocVia]=Original
'Personalizacao             [DocPer]=

''formato
''Saida/Impressora           [DocPrt]=PAG_W
'Saida/Impressora           [DocPrt]=PAG_W,PRV
'Linhas por pagina          [DocLpg]=30
'Colunas por linha          [DocCol]=132
'Formato do papel           [DocPap]=72L
'Ajustar pagina             [DocApg]=0
'Especifico do documento    [DocEsp]=TipoLst=GRF

''funcoes de listagem
'Listar cabecalho            [FxCAB]=Doc2_Cab
'Listar linhas               [FxLIN]=Doc2_Lin
'Listar fim                  [FxFIM]=Doc2_Fim

''controlo de listagem SQL
'Gerador de dados a listar  [SQLDat]=GerDli
'Subtotalizadores           [SQLSbt]=C01
'##


'-------------------------------------------------------------------------------
#VAR - Variaveis
'-------------------------------------------------------------------------------
Tipo     = MemTxt$(1)
Pag      = Doc_CntPag
DataExt  = FrmVal$(Sig_DtHoje,45,0)


TotNr    = FrmNum$(6.0,TotNr)
SbtId    = SbtIde$
SbtNr    = FrmNum$(6.0,SbtNr)

'Campos
C01 = GpeCodFrm$("SEC",SqlCmp$("C01"))
C02 = GpeTabCon$("SEC",SqlCmp$("C02"),"ABRV")
C03 = left$(SqlCmp$("C03"), 5)
C04 = left$(SqlCmp$("C04"), 40)
C05 = FrmMoe$("", 11,SqlCmp("C05"))
C05_T0=FrmNum$( 8.2,Total(C05,0))
C05_N0=FrmNum$(6.0,TotCnt("C01",0))
T05   =FrmNum$( 8.2,Total(C05,0))
C06 = FrmMoe$("", 11,SqlCmp("C06"))
C06_T0=FrmNum$( 8.2,Total(C06,0))
C06_N0=FrmNum$(6.0,TotCnt("C01",0))
T06   =FrmNum$( 8.2,Total(C06,0))
C07 = GpeTabCon$("CSS",SqlCmp("C07"),"DES_P")
C08 = FrmMoe$("", 11,SqlCmp("C05")+SqlCmp("C06"))
T08   =FrmNum$( 8.2,Total(C08,0))
C09 = FrmMoe$("", 11,SqlCmp("C06")*2*GpeTabCon$("CSS",SqlCmp("C07"),"DES_P")/100)
T09   =FrmNum$( 8.2,Total(C09,0))
ide=ide$

'Subtotais
C05_T1=FrmNum$( 8.2,Total(C05,1))
C05_N1=FrmNum$(6.0,TotCnt("C01",1))
C06_T1=FrmNum$( 8.2,Total(C06,1))
C06_N1=FrmNum$(6.0,TotCnt("C01",1))
C08_T1=FrmNum$( 8.2,Total(C08,1))
C09_T1=FrmNum$( 8.2,Total(C09,1))

##


'-------------------------------------------------------------------------------
#PGM - Programa/Funcoes
'-------------------------------------------------------------------------------
SUB FxIni 'funcao de inicializacao
'modo WIN
PrWIN AJT_F, 56.7,  56.7                           'ajuste para milimetros
PrWIN AJT_D,-280.0,-280.0                          'deslocamento de ajuste
'PrWIN IMG_F, 1, VarTx$("[SIG_DIR.DIV],OliLogo.bmp","R")     'imagem (logotipo)
PrWIN ET,  2                                       'espessura de traco

dimLinNor=4.4                                      'altura de uma linha normal
dimLinCab=6.6                                      'altura de uma linha de cabecalho

cnt=0                                              'limpar contador
end sub


SUB FxFim 'funcao de finalizacao
PrWIN FON, "REG"                                   'limpar registo de fontes
end sub


SUB Lst_AJT 'ajuste
end sub



'- Doc1 ------------------------------------------------------------------------
SUB Doc1_FimAjt 'fim de pagina intermedia
'TotNr=TotCnt("C01",0)                             'numero de registos
?====================================================================================================================================
'if UsaTot > 0 then
'?
'?====================================================================================================================================
'print "Linhas:" Doc_CntLin                        'numero da linha - DEBUG
'end if

FxDiv LstPer,SP                                    'fim de pagina
'Print PrtCmd("[SP]");                             'fim de pagina
end sub


SUB Doc1_CabIni 'inicializar listagem
cntDoc=0
UsaTot=1
end sub


SUB Doc1_Cab 'cabecalho de listagem
FxDiv LstIde,16CPI,0
print TxTit$("TT=16CPI, LD, PT=66C, TL=16CPI",MemTxt$(1))
?Data : @DataExt                                                                                                     Folha No : @Pag#
'123456789.123456789.123456789.123456789.123456789.123456789.123456789.123456789.123456789.123456789.123456789.123456789.123456789.12
?====================================================================================================================================
?            Nome       N                    Nome                      Frias       Sub.Frias          Total    Taxa     Encargos
?====================================================================================================================================
'AAAAAA AAAAAAAAAAAAAA AAAAA AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA 9999,990.00 9999,990.00 90.00
'<----> <------------> <---> <--------------------------------------> <---------> <---------> <--->
end sub


SUB Doc1_Lin 'linha de valores
?@C01   @C02           @C03  @C04                                     @C05          @C06           @C08          @C07   @C09                                 #
end sub


SUB Doc1_Fim 'fim de listagem
TotNr=TotCnt("C01",0)                              'numero de registos
?====================================================================================================================================
if UsaTot > 0 then
?  Total   :           @TotNr                                         @T05          @T06           @T08                 @T09             #
?====================================================================================================================================
'print "Linhas:" Doc_CntLin                        'numero da linha - DEBUG
end if

FxDiv LstPer,SP                                    'fim de pagina
'Print PrtCmd("[SP]");                             'fim de pagina
end sub


SUB Doc1_LinTit1 'titulo de subtotal 1
tmp=CntLin("MIN",5)                                'minimo de linhas
tmp=CntLin("INC",1)                                'contar linha

grp$=SbtInf$("ACT",1)                     'grupo
tmp =SqlOpcAct("Grp",grp$)                         'actualizar valor do grupo
'grVer$=xxxFrmXyz$(grp$)                           'formatar
grVer$=grp$                                        'copiar

'ide$=SqlCalc$("GrpIde")
ide$=GpeTabCon$("SEC",SqlCmp$("C02"),"ABRV")                            'pesquisar identificador de grupo
print tab(5) "Secco " grVer$ "     " ide$        'identificar grupo

'tmp=CntLin("INC",1)                               'contar linha
'print                                             'separar

'print "Linhas:" Doc_CntLin                        'numero da linha - DEBUG
end sub


SUB Doc1_LinSbt1 'valor de subtotal 1
grp$   =SbtInf$("ANT",1)                  'grupo
'grVer$=xxxFrmXyz$(grp$)                           'formatar
grVer$ =grp$                                       'copiar
SbtIde$=grVer$                                     'identificacao de subtotal
SbtNr  =TotCnt("C01",1)                   'numero de registos
?
?  Total Seccao : @SbtId  @ide         @SbtNr                         @C05_T1       @C06_T1        @C08_T1              @C09_T1      #
?

tmp=CntLin("INC",2)                                'contar linhas
x=TotLpz(1)                               'limpar totais

'print "Linhas:" Doc_CntLin                        'numero da linha - DEBUG
end sub



'- Doc2 ------------------------------------------------------------------------
Sub Cab132 'cabecalho para 132 colunas
PrWIN AJT_B, 10.0, 0.0                             'posicao base

cabX1=3                                            'limite X1
cabX2=270                                          'limite X2
cabY1=25                                           'limite Y1
cabY2=cabY1+CabLin*dimLinCab                       'limite Y2
cabYm=cabY2+35*dimLinNor                           'limite Y maximo

PrWIN COR_F, 15                                    'cor de fundo

PrWIN FON, 10, 1                                   'activar fonte
'PrWIN TX_N, cabX2-100,  5,VarTx$(EMP_INF_NOME$)    'nome da empresa
PrWIN TX_N, cabX2-100,  5,EmpCurIde$("IDE")        'nome da empresa
PrWIN FON, 18, 1                             	   'activar fonte
PrWin FON, "BOLD+"                                 'activar bold
PrWIN TX_CTR,  cabX1, 5, cabX2, cabY1,MemTxt$(1)   'titulo centrado
PrWin FON, "BOLD-"                                 'desactivar bold
PrWIN FON, 10, 1                             	   'activar fonte

py   =cabY1-dimLinNor-1                            'posicao Y
pxFol=CabX2-30                                     'posicao X para folha
pxPag=CabX2-10                                     'posicao X para pagina

PrWIN TX_N,   05, py,"Data :"                      'data
PrWIN TX_N,   16, py,@DataExt                      'listar data
PrWIN TX_N,pxFol, py,"Folha No :"                  'folha
PrWIN TX_N,pxPag, py,@Pag                          'numero da folha

PrWIN COR_E, 200, 200, 200                         'cor de enchimento RGB
PrWIN GR_ME, 0                                     'modo de enchimento

PrWIN GR_CE,  cabX1, cabY1, cabX2, cabY2, 2        'caixa do cabecalho

if UsaEnv=1 then
PrWIN GR_CX,  cabX1, cabY1, cabX2, cabYm, 2     'caixa envolvente
end if
End Sub


SUB Doc2_Cab 'cabecalho
CabLin = 1                                         'linhas de cabecalho
call Cab132                                        'listar cabecalho
PrWIN AJT_B,  8.0, 0.0                             'posicao base

PrWin FON, "BOLD+"                                 'activar bold
call Doc2_CabCol                                   'titulos das colunas
PrWin FON, "BOLD-"                                 'desactivar bold
end sub


SUB Doc2_LinPos 'posicao de linha
PrWIN AJT_B,  8, 31+Doc_CntLin*4.4                 'posicao base
'PrWIN TX_N,  -3,  0,Doc_CntLin                    'numero da linha - DEBUG
end sub


SUB Doc2_Lin 'linha
call Doc2_LinPos                                   'posicionar linha
call Doc2_LinCol                                   'listar colunas
end sub


SUB Doc2_Fim 'fim de listagem
TotNr=TotCnt("C01",0)                              'numero de registos
tmp=CntLin("INC",-2)                               'contar linha (sem nova pagina)
call Doc2_LinPos                                   'posicionar linha
if UsaTot > 0 then
call Doc2_FimCol                                'listar totais
end if

PrWIN FP                                           'fim de pagina
end sub


SUB Doc2_FimAjt 'fim de pagina intermedia
'TotNr=TotCnt("C01",0)                             'numero de registos
'tmp=CntLin("INC",-1)                              'contar linha (sem nova pagina)
'call Doc2_LinPos                                  'posicionar linha
'if UsaTot > 0 then
'   call Doc2_FimCol                               'listar totais
'end if

PrWIN FP                                           'fim de pagina
end sub


SUB Doc2_CabIni 'inicializar listagem
cntDoc=0                                           'limpar contador
UsaTot=1                                  'usar totais
UsaEnv=1                                  'usar envolvente
UsaSpc=1                                  'usar separador de colunas
end sub


SUB Doc2_CabCol
PrWIN TX_CTR,  5.0,cabY1, 19.7,cabY2,""
PrWIN TX_CTR, 19.7,cabY1, 51.2,cabY2,"Nome"
PrWIN TX_CTR, 51.2,cabY1, 63.8,cabY2,"N"
PrWIN TX_CTR, 63.8,cabY1,149.9,cabY2,"Nome "
PrWIN TX_CTR,149.9,cabY1,175.1,cabY2,"Frias"
PrWIN TX_CTR,175.1,cabY1,200.3,cabY2,"Sub.Frias"
PrWIN TX_CTR,200.3,cabY1,210.8,cabY2,"Taxa"

if UsaSpc > 0 then
PrWIN GR_LI, 19.7,cabY1, 19.7,cabYm,2
PrWIN GR_LI, 51.2,cabY1, 51.2,cabYm,2
PrWIN GR_LI, 63.8,cabY1, 63.8,cabYm,2
PrWIN GR_LI,149.9,cabY1,149.9,cabYm,2
PrWIN GR_LI,175.1,cabY1,175.1,cabYm,2
PrWIN GR_LI,200.3,cabY1,200.3,cabYm,2
PrWIN GR_LI,210.8,cabY1,210.8,cabYm,2
end if
end sub


SUB Doc2_LinCol
PrWIN TX_N,  6.0,0,@C01
PrWIN TX_N, 20.7,0,@C02
PrWIN TX_N, 52.2,0,@C03
PrWIN TX_N, 64.8,0,@C04
PrWIN TX_NP,150.9,0,"N",@C05
PrWIN TX_NP,176.1,0,"N",@C06
PrWIN TX_NP,201.3,0,"N",@C07
end sub


SUB Doc2_LinTit1 'titulo de subtotal 1
tmp=CntLin("MIN",5)                                'minimo de linhas
tmp=CntLin("INC",1)                                'contar linha

grp$=SbtInf$("ACT",1)                     'grupo
tmp =SqlOpcAct("Grp",grp$)                         'actualizar valor do grupo
'grVer$=xxxFrmXyz$(grp$)                           'formatar
grVer$=grp$                                        'copiar

ide$=SqlCalc$("GrpIde")                            'pesquisar identificador de grupo
txi$="Grupo : "+grVer$+"     "+ide$                'identificar grupo

call Doc2_LinPos                                   'posicionar linha
PrWIN TX_N, 06,  0,txi$                            'listar identificacao de grupo
end sub


SUB Doc2_LinSbt1 'valor de subtotal 1
grp$   =SbtInf$("ANT",1)                  'grupo
'grVer$=xxxFrmXyz$(grp$)                           'formatar
grVer$ =grp$                                       'copiar
SbtIde$=grVer$                                     'identificacao de subtotal
SbtNr  =TotCnt("C01",1)                   'numero de registos

tmp=CntLin("INC",1)                                'contar linha
call Doc2_LinPos                                   'posicionar linha
call Doc2_LinSbt1Col                      'listar valores

tmp=CntLin("INC",1)                                'contar linha
x=TotLpz(1)                               'limpar totais
end sub


SUB Doc2_FimCol
PrWIN TX_NP, 10.0,0,"N",@TotNr
PrWIN TX_N, 22.7,0,"Totais:"
PrWIN TX_NP,150.9,0,"N",@T05
PrWIN TX_NP,176.1,0,"N",@T06
end sub


SUB Doc2_LinSbt1Col
PrWIN TX_NP, 10.0,0,"N",@SbtNr
PrWIN TX_N, 22.7,0,"Subtotais:"
PrWIN TX_N, 54.2,0,SbtIde$
PrWIN TX_NP,150.9,0,"N",@C05_T1
PrWIN TX_NP,176.1,0,"N",@C06_T1
end sub


##


'-------------------------------------------------------------------------------
#GRP - Grupos
'-------------------------------------------------------------------------------
Identificacao                        [Ide]=DefBas
Tipo de listagem                  [TipLst]=16CPI_132

Colunas por linha                 [ColLin]=132
Tipo de letra                     [TipLtr]=16CPI

Separacao entre colunas           [ColSep]=1
Titulo da listagem                [LstTit]=Mapa Provises
Informacao adicional              [InfAdi]=Informao Adicional

'opcoes para modo TEXTO
Identificacao de total          [T_TotIde]=Total   :           @TotNr
Identificacao de subtotal       [T_SbtIde]=Subtotal: @SbtId    @SbtNr
Posicao X para total/subtotal    [T_TotPx]=2

'opcoes para modo GRAFICO
Identificacao de total          [G_TotIde]=Total   :
Identificacao de subtotal       [G_SbtIde]=Subtotal:
Posicao X para total/subtotal    [G_TotPx]=20
Dimensao X para total/subtotal   [G_TotDx]=90
Dimensao X para grupo subtotal   [G_GrpDx]=40

Posicao X minima                  [G_Xmin]=5
Posicao X maxima                  [G_Xmax]=270
Distancia X para coluna          [G_ColDx]=1
Dimensao X para caracteres       [G_CarDx]=2.1
Usa separador de colunas        [G_UsaSpc]=1
Usa envolvente                  [G_UsaEnv]=1

'dados a usar
Grupos a usar              [GrpUsa]=GPE_MST
Grupo corrente             [GrpCur]=GPE_MST
Base de dados para SQL      [SqlDb]=EmpFic$("EMP","Gpe,Gpe.mdb")
##


'-------------------------------------------------------------------------------
#GRP.CMP - Campos por grupo
'-------------------------------------------------------------------------------
'formatos para totalizadores
TotV [TOT]=C[>CmpNum<]_T[>SbtNum<]=FrmNum$([>CmpFrmV<],Total(C[>CmpNum<],[>SbtNum<]))
TotN [CNT]=C[>CmpNum<]_N[>SbtNum<]=FrmNum$([>CmpFrmN<],TotCnt("C01",[>SbtNum<]))
##


'-------------------------------------------------------------------------------
#GRP - Grupos
'-------------------------------------------------------------------------------
Identificacao                 [Ide]=VarFix
##


'-------------------------------------------------------------------------------
#GRP.CMP - Campos por grupo
'-------------------------------------------------------------------------------
Tipo     = MemTxt$(1)
Pag      = Doc_CntPag
DataExt  = FrmVal$(Sig_DtHoje,45,0)


TotNr    = FrmNum$(6.0,TotNr)
SbtId    = SbtIde$
SbtNr    = FrmNum$(6.0,SbtNr)
##


'-------------------------------------------------------------------------------
#GRP - Grupos
'-------------------------------------------------------------------------------
Identificacao       [Ide]=CmpUsa01
##


'-------------------------------------------------------------------------------
#GRP.CMP - Campos por grupo
'-------------------------------------------------------------------------------
[IDE=C01][COD=GPE_MST_SEC][DES=][TPC=V][EXP=Gpe_Mst_Sec$][FRM=6+1][TPV=T][SBT=SIM][LIM=][TOT=0][ORD=1][ASP=GpeCodFrm$("SEC",[VAR])][DIV=]
[IDE=C02][COD=GPE_MST_SecAbrv][DES=Nome][TPC=V][EXP=Gpe_Mst_Sec$][FRM=14+1][TPV=T][SBT=][LIM=][TOT=0][ORD=0][ASP=GpeTabCon$("SEC",[VAR],"ABRV")][DIV=]
[IDE=C03][COD=GPE_MST_Trb][DES=N][TPC=V][EXP=Gpe_Mst_Trb$][FRM=5+1][TPV=T][SBT=][LIM=][TOT=0][ORD=0][ASP=left$([VAR],[DIG])][DIV=]
[IDE=C04][COD=GPE_MST_Nome][DES=Nome ][TPC=V][EXP=Gpe_Mst_Nome$][FRM=40+1][TPV=T][SBT=][LIM=][TOT=0][ORD=0][ASP=left$([VAR],[DIG])][DIV=]
[IDE=C05][COD=GPE_MST_Vbase][DES=Frias][TPC=V][EXP=Gpe_Mst_Vbase][FRM=8.2+1][TPV=N][SBT=][LIM=][TOT=1][ORD=0][ASP=FrmMoe$("",[NDI],[VAR])][DIV=]
[IDE=C06][COD=GPE_MST_Vbase][DES=Sub.Frias][TPC=V][EXP=Gpe_Mst_Vbase][FRM=8.2+1][TPV=N][SBT=][LIM=][TOT=1][ORD=0][ASP=FrmMoe$("",[NDI],[VAR])][DIV=]
[IDE=C07][COD=GPE_MST_CrssTxEmp][DES=Taxa][TPC=V][EXP=Gpe_Mst_Crss][FRM=2.2+1][TPV=N][SBT=][LIM=][TOT=0][ORD=0][ASP=GpeTabCon$("CSS",[VAR],"DES_P")][DIV=]
##


'-------------------------------------------------------------------------------
#GRP - Grupos
'-------------------------------------------------------------------------------
Identificacao       [Ide]=FxPgm
##


'-------------------------------------------------------------------------------
#GRP.CMP - Campos por grupo
'-------------------------------------------------------------------------------
'-----------------------------------------------------------------------------
' Funcoes para inicializacao
'-----------------------------------------------------------------------------
'<------------------------------------------------>'posicao de comentario

SUB I_FxIni 'funcao de inicializacao
'modo WIN
PrWIN AJT_F, 56.7,  56.7                           'ajuste para milimetros
PrWIN AJT_D,-280.0,-280.0                          'deslocamento de ajuste
'PrWIN IMG_F, 1, VarTx$("[SIG_DIR.DIV],OliLogo.bmp","R")     'imagem (logotipo)
PrWIN ET,  2                                       'espessura de traco

dimLinNor=4.4                                      'altura de uma linha normal
dimLinCab=6.6                                      'altura de uma linha de cabecalho

cnt=0                                              'limpar contador
end sub


SUB I_FxFim 'funcao de finalizacao
PrWIN FON, "REG"                                   'limpar registo de fontes
end sub


'-----------------------------------------------------------------------------
' Funcoes diversas
'-----------------------------------------------------------------------------
SUB D_Lst_AJT 'ajuste
end sub


'-----------------------------------------------------------------------------
' Listagem em modo TEXTO
'-----------------------------------------------------------------------------
SUB T_$Doc1_CabIni 'inicializar listagem
cntDoc=0
UsaTot=[>UsaTot<]
end sub


SUB T_$Doc1_Cab 'cabecalho de listagem
FxDiv LstIde,16CPI,0
print TxTit$("TT=16CPI, LD, PT=66C, TL=16CPI",MemTxt$(1))
?Data : @DataExt                                                                                                     Folha No : @Pag#
'123456789.123456789.123456789.123456789.123456789.123456789.123456789.123456789.123456789.123456789.123456789.123456789.123456789.12
?====================================================================================================================================
?[>ColCab<]
?====================================================================================================================================
'[>RegSim<]
'[>RegDim<]
end sub


SUB T_$Doc1_Lin 'linha de valores
?[>ColLin<]
end sub


SUB T_$Doc1_LinTit[>SbtNum<] 'titulo de subtotal [>SbtNum<]
tmp=CntLin("MIN",5)                                'minimo de linhas
tmp=CntLin("INC",1)                                'contar linha

grp$=SbtInf$("ACT",[>SbtNum<])                     'grupo
tmp =SqlOpcAct("Grp",grp$)                         'actualizar valor do grupo
'grVer$=xxxFrmXyz$(grp$)                           'formatar
grVer$=grp$                                        'copiar

ide$=SqlCalc$("GrpIde")                            'pesquisar identificador de grupo
print tab(5) "Grupo : " grVer$ "     " ide$        'identificar grupo

'tmp=CntLin("INC",1)                               'contar linha
'print                                             'separar

'print "Linhas:" Doc_CntLin                        'numero da linha - DEBUG
end sub


SUB T_$Doc1_LinSbt[>SbtNum<] 'valor de subtotal [>SbtNum<]
grp$   =SbtInf$("ANT",[>SbtNum<])                  'grupo
'grVer$=xxxFrmXyz$(grp$)                           'formatar
grVer$ =grp$                                       'copiar
SbtIde$=grVer$                                     'identificacao de subtotal
SbtNr  =TotCnt("C01",[>SbtNum<])                   'numero de registos

?[>ColSbt<]
?

tmp=CntLin("INC",2)                                'contar linhas
x=TotLpz([>SbtNum<])                               'limpar totais

'print "Linhas:" Doc_CntLin                        'numero da linha - DEBUG
end sub


SUB T_$Doc1_Fim 'fim de listagem
TotNr=TotCnt("C01",0)                              'numero de registos
?====================================================================================================================================
if UsaTot > 0 then
?[>ColFim<]
?====================================================================================================================================
'print "Linhas:" Doc_CntLin                        'numero da linha - DEBUG
end if

FxDiv LstPer,SP                                    'fim de pagina
'Print PrtCmd("[SP]");                             'fim de pagina
end sub


SUB T_Doc1_FimAjt 'fim de pagina intermedia
'TotNr=TotCnt("C01",0)                             'numero de registos
?====================================================================================================================================
'if UsaTot > 0 then
'?[>ColFim<]
'?====================================================================================================================================
'print "Linhas:" Doc_CntLin                        'numero da linha - DEBUG
'end if

FxDiv LstPer,SP                                    'fim de pagina
'Print PrtCmd("[SP]");                             'fim de pagina
end sub


'-----------------------------------------------------------------------------
' Listagem em modo WINDOWS
'-----------------------------------------------------------------------------
Sub G_Cab132 'cabecalho para 132 colunas
PrWIN AJT_B, 10.0, 0.0                             'posicao base

cabX1=3                                            'limite X1
cabX2=270                                          'limite X2
cabY1=25                                           'limite Y1
cabY2=cabY1+CabLin*dimLinCab                       'limite Y2
cabYm=cabY2+35*dimLinNor                           'limite Y maximo

PrWIN COR_F, 15                                    'cor de fundo

PrWIN FON, 10, 1                                   'activar fonte
'PrWIN TX_N, cabX2-100,  5,VarTx$(EMP_INF_NOME$)    'nome da empresa
PrWIN TX_N, cabX2-100,  5,EmpCurIde$("IDE")        'nome da empresa
PrWIN FON, 18, 1                             	   'activar fonte
PrWin FON, "BOLD+"                                 'activar bold
PrWIN TX_CTR,  cabX1, 5, cabX2, cabY1,MemTxt$(1)   'titulo centrado
PrWin FON, "BOLD-"                                 'desactivar bold
PrWIN FON, 10, 1                             	   'activar fonte

py   =cabY1-dimLinNor-1                            'posicao Y
pxFol=CabX2-30                                     'posicao X para folha
pxPag=CabX2-10                                     'posicao X para pagina

PrWIN TX_N,   05, py,"Data :"                      'data
PrWIN TX_N,   16, py,@DataExt                      'listar data
PrWIN TX_N,pxFol, py,"Folha No :"                  'folha
PrWIN TX_N,pxPag, py,@Pag                          'numero da folha

PrWIN COR_E, 200, 200, 200                         'cor de enchimento RGB
PrWIN GR_ME, 0                                     'modo de enchimento

PrWIN GR_CE,  cabX1, cabY1, cabX2, cabY2, 2        'caixa do cabecalho

if UsaEnv=1 then
PrWIN GR_CX,  cabX1, cabY1, cabX2, cabYm, 2     'caixa envolvente
end if
End Sub


SUB G_Doc2_Cab 'cabecalho
CabLin = 1                                         'linhas de cabecalho
call Cab132                                        'listar cabecalho
PrWIN AJT_B,  8.0, 0.0                             'posicao base

PrWin FON, "BOLD+"                                 'activar bold
call Doc2_CabCol                                   'titulos das colunas
PrWin FON, "BOLD-"                                 'desactivar bold
end sub


SUB G_Doc2_LinPos 'posicao de linha
PrWIN AJT_B,  8, 31+Doc_CntLin*4.4                 'posicao base
'PrWIN TX_N,  -3,  0,Doc_CntLin                    'numero da linha - DEBUG
end sub


SUB G_Doc2_Lin 'linha
call Doc2_LinPos                                   'posicionar linha
call Doc2_LinCol                                   'listar colunas
end sub


SUB G_Doc2_Fim 'fim de listagem
TotNr=TotCnt("C01",0)                              'numero de registos
tmp=CntLin("INC",-2)                               'contar linha (sem nova pagina)
call Doc2_LinPos                                   'posicionar linha
if UsaTot > 0 then
call Doc2_FimCol                                'listar totais
end if

PrWIN FP                                           'fim de pagina
end sub


SUB G_Doc2_FimAjt 'fim de pagina intermedia
'TotNr=TotCnt("C01",0)                             'numero de registos
'tmp=CntLin("INC",-1)                              'contar linha (sem nova pagina)
'call Doc2_LinPos                                  'posicionar linha
'if UsaTot > 0 then
'   call Doc2_FimCol                               'listar totais
'end if

PrWIN FP                                           'fim de pagina
end sub


'- Matrizes para Doc2 --------------------------------------------------------
SUB G_$Doc2_CabIni 'inicializar listagem
cntDoc=0                                           'limpar contador
UsaTot=[>UsaTot<]                                  'usar totais
UsaEnv=[>UsaEnv<]                                  'usar envolvente
UsaSpc=[>UsaSpc<]                                  'usar separador de colunas
end sub


SUB G_$Doc2_LinTit[>SbtNum<] 'titulo de subtotal [>SbtNum<]
tmp=CntLin("MIN",5)                                'minimo de linhas
tmp=CntLin("INC",1)                                'contar linha

grp$=SbtInf$("ACT",[>SbtNum<])                     'grupo
tmp =SqlOpcAct("Grp",grp$)                         'actualizar valor do grupo
'grVer$=xxxFrmXyz$(grp$)                           'formatar
grVer$=grp$                                        'copiar

ide$=SqlCalc$("GrpIde")                            'pesquisar identificador de grupo
txi$="Grupo : "+grVer$+"     "+ide$                'identificar grupo

call Doc2_LinPos                                   'posicionar linha
PrWIN TX_N, 06,  0,txi$                            'listar identificacao de grupo
end sub


SUB G_$Doc2_LinSbt[>SbtNum<] 'valor de subtotal [>SbtNum<]
grp$   =SbtInf$("ANT",[>SbtNum<])                  'grupo
'grVer$=xxxFrmXyz$(grp$)                           'formatar
grVer$ =grp$                                       'copiar
SbtIde$=grVer$                                     'identificacao de subtotal
SbtNr  =TotCnt("C01",[>SbtNum<])                   'numero de registos

tmp=CntLin("INC",1)                                'contar linha
call Doc2_LinPos                                   'posicionar linha
call Doc2_LinSbt[>SbtNum<]Col                      'listar valores

tmp=CntLin("INC",1)                                'contar linha
x=TotLpz([>SbtNum<])                               'limpar totais
end sub

##

